<?php

class mgcCbEvo_command
{
	/* Command */
	var $identifier     	= "";
	var $version        	= "";
	var $title          	= "";
	var $description    	= "";
	var $syntax         	= "";
	var $size           	= 0;
	var $chanid         	= 0;
	var $usergroupids   	= "";
	var $userids        	= "";
	var $helpphrase     	= "";
	var $autocomplete		= "";
	
	/* Author */
	var $authorname  = "";
	var $authorurl	  = "";
	
	/* Command configuration */
	var $with_parameters 			= 0;
	var $can_be_in_channel 			= 0;
	var $contains_message 			= 0;
	var $accepts_userpref			= 0;
	var $can_be_in_gen_channel 	= 0;
	var $from_user_to_user			= 0;
	var $accepts_bbcode				= 0;
	var $with_username_in_message	= 0;
	var $do_format_in_own_channel = 0;
	
	/* Command php codes */
	var $phpcode_chats_sending			= "";
	var $phpcode_chats_retrieving 	= "";
	var $phpcode_chatbox_display		= "";
	var $phpcode_chatbox_ar_display 	= "";
	
	/* Command html code */
	var $htmlcode_chats_display	= "";
	var $htmlcode_chatbit_menu    = "";
	
	/* JS file to include */
	var $js_file = "";
	
	/* vBulletin relative */
	var $options_varnames = array();
	var $phrases_varnames = array();
	
	function mgcCbEvo_command($command)
	{
		$this->identifier     = $command['identifier'];
		$this->version        = $command['version'];
		$this->title          = $command['title'];
		$this->description    = $command['description'];
		$this->syntax         = $command['syntax'];
		$this->size           = $command['size'];
		$this->usergroupids   = $command['usergroupids'];
		$this->userids        = $command['userids'];
		$this->chanid         = $command['chanid'];
		$this->authorname     = $command['authorname'];
		$this->authorurl      = $command['authorurl'];
		$this->helpphrase     = $command['helpphrase'];
	
		/* Retrieving of the command configuration thanks to the bitfield */
		$this->with_parameters	 		= $command['cmd_bitfield'] & 1;
		$this->can_be_in_channel 		= $command['cmd_bitfield'] & 2;
		$this->contains_message  		= $command['cmd_bitfield'] & 4;
		$this->accepts_userpref  		= $command['cmd_bitfield'] & 8;
		$this->can_be_in_gen_channel	= $command['cmd_bitfield'] & 16;
		$this->from_user_to_user  		= $command['cmd_bitfield'] & 32;
		$this->accepts_bbcode			= $command['cmd_bitfield'] & 64;
		$this->with_username_in_message = $command['cmd_bitfield'] & 128;
		$this->do_format_in_own_channel = $command['cmd_bitfield'] & 256;
		
		
		$this->phpcode_chats_sending	  = $command['phpcode_chats_sending'];
		$this->phpcode_chats_retrieving = $command['phpcode_chats_retrieving'];
		$this->phpcode_chatbox_display	= $command['phpcode_chatbox_display'];
		$this->phpcode_chatbox_ar_display = $command['phpcode_chatbox_ar_display'];

		$this->htmlcode_chats_display	 = $command['htmlcode_chats_display'];
		$this->htmlcode_chatbit_menu	 = $command['htmlcode_chatbit_menu'];		

		$this->js_file = $command['js_file'];
		
		$this->options_varnames = $command['options_varnames'];
		$this->phrases_varnames = $command['phrases_varnames'];
		
		$this->autocomplete = $command['autocomplete'];
	}
	
	function construct_bitfield($misc_array)
	{
		return
			($misc_array['with_parameters'] ? 1 : 0)
			+ ($misc_array['can_be_in_channel'] ? 2 : 0)
			+ ($misc_array['contains_message'] ? 4 : 0)
			+ ($misc_array['accepts_userpref'] ? 8 : 0)
			+ ($misc_array['can_be_in_gen_channel'] ? 16 : 0)
			+ ($misc_array['from_user_to_user'] ? 32 : 0)
			+ ($misc_array['accepts_bbcode'] ? 64 : 0)
			+ ($misc_array['with_username_in_message'] ? 128 : 0)			
         + ($misc_array['do_format_in_own_channel'] ? 256 : 0);
	}
	
}

?>